///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit VersionInfo;
////////////////////////////////////////////
//           //
//                       //
//              VCL-                //
//           Crafted by Sagrer            //
//               ver 1.0                  //
////////////////////////////////////////////

interface
uses
  Windows, messages, SysUtils;

type
  TVerInfoFromFile = class
    CompanyName : string;
    FileDescription : string;
    FileVersion : string;
    InternalName : string;
    LegalCopyright : string;
    OriginalFilename : string;
    ProductName : string;
    ProductVersion : string;
    Comments : string;
    CraftedBy : string;
    Function LoadInfo(const FileName : string) : boolean;
    Function GetValue(const Value : string): string;
  private
    BuffSize : Cardinal;
    Dummy : Cardinal;
    Buffer : pointer;
    LangInfa : pointer;
    Int1 : integer;
    LangCharSet, LangInfoStr : string;
  end;

implementation

Function TVerInfoFromFile.LoadInfo(const FileName : string) : boolean;

begin
  //      .

  //        .
  BuffSize := GetFileVersionInfoSize(PChar(FileName),Dummy);
  //MsgOK(Int2Str(BuffSize));   // .
  Buffer := AllocMem(BuffSize);  //   ,  .
  //         .
  GetFileVersionInfo(pchar(FileName),Dummy,BuffSize,Buffer);

  //      ...
  VerQueryValue(Buffer,'\VarFileInfo\Translation',LangInfa,Dummy);
  If Dummy >= 4 then begin
    Int1 := 0;  //             HEX.
    StrLCopy(@Int1, pchar(LangInfa), 2);  //  2   LangInfa  Int1
    LangCharSet := IntToHex(Int1,4);   //   HEX :)
    StrLCopy(@Int1,pchar(LangInfa)+2,2); // 2- 2 .
    LangInfoStr := LangCharSet+IntToHex(Int1,4);
  end;

  //        :).
  CompanyName := GetValue('CompanyName');
  FileDescription := GetValue('FileDescription');
  FileVersion := GetValue('FileVersion');
  InternalName := GetValue('InternalName');
  LegalCopyright := GetValue('LegalCopyright');
  OriginalFilename := GetValue('OriginalFilename');
  ProductName := GetValue('ProductName');
  ProductVersion := GetValue('ProductVersion');
  Comments := GetValue('Comments');
  CraftedBy := GetValue('CraftedBy');

  //   , .
  Result := true;
end;

Function TVerInfoFromFile.GetValue(const Value : string): string;
var
  TempStr : PChar;
begin
  //     :).
  //   LoadInfo,     
  //.     LoadInfo   
  //  ...

  VerQueryValue(Buffer,pchar('\StringFileInfo\'+LangInfoStr+'\'+Value),pointer(TempStr),Dummy);
  if Dummy > 0 then begin
    //  .     :)
    Result := TempStr;
  end
  else begin
    //   -  "".
    Result := 'n/a';
  end;  
    
end;

end.
